{   This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   ---------------------------------------------------------------------------

    Author : Luc DAVID Email: luckylazarus@free.fr
    2006 - 2009

   --------------------------------------------------------------------------- }

   { BUGS - TODO

   }
    
unit SQLitePassDboTest;
{$i ..\..\Sources\SqlitePassDbo.inc}

interface

uses

  {$IFDEF FPC}
  LResources,
  {$ELSE}
    {$IFDEF NeedUTF8Vcl}
     {  If you use one of the newer Delphi compilers make sure you set the
        codepage to 65001 in the compiler options and rebuild }
     UTF8VCL,
    {$ENDIF NeedUTF8Vcl}
  {$ENDIF}

  {$IFDEF WIN32}
  Windows,
  {$ENDIF}

  {.$DEFINE DEBUG_SQLITEPASS}
  {$IFDEF DEBUG_SQLITEPASS}
   SqlitePassDebug,
  {$ENDIF}

  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, StdCtrls, ComCtrls, ExtCtrls, DBCtrls, SqlitePassDbo,
  ExtDlgs, ActnList, Menus, Buttons, ImgList, SqlitePassUtils,
  DBActns, SqlitePassVisualTools, SqlitePassIndexesDialog;

Const
 MenuDatabaseItemsCount = 18;
 MaxMRUFilesCount = 6;
 GridFieldDefsLeftMargin = 2;

type

  { TMainForm }
  TMainForm = class(TForm)
    Label22: TLabel;
    Panel1: TPanel;
    PanelDatabaseToolBar: TPanel;
    PanelPageControl: TPanel;
    PageControl: TPageControl;
    TsDatabase: TTabSheet;
    TsDataset: TTabSheet;
    DataSourcePlug: TDataSource;
    OpenPictureDialog: TOpenPictureDialog;
    SavePictureDialog: TSavePictureDialog;
    MainMenu: TMainMenu;
    MainActionList: TActionList;
    ActionApplicationQuit: TAction;
    OpenFileDialog: TOpenDialog;
    Database: TMenuItem;
    Open1: TMenuItem;
    Close1: TMenuItem;
    MenuSeparator1: TMenuItem;
    Quit1: TMenuItem;
    SaveFileDialog: TSaveDialog;
    TsSQL: TTabSheet;
    PageControlDataset: TPageControl;
    TsDatasetStructure: TTabSheet;
    TsDatasetData: TTabSheet;
    Panel3: TPanel;
    DBImage: TDBImage;
    BtLoadPictureFromFile: TSpeedButton;
    BtClearPicture: TSpeedButton;
    BtSavePictureToFile: TSpeedButton;
    DBMemo: TDBMemo;
    ComboBoxGraphicFields: TComboBox;
    CbShowGraphic: TCheckBox;
    CbShowMemo: TCheckBox;
    BtLoadMemoFromFile: TSpeedButton;
    BtClearMemo: TSpeedButton;
    BtSaveMemoToFile: TSpeedButton;
    ComboBoxMemoFields: TComboBox;
    PanelNoRecordFound: TPanel;
    Help1: TMenuItem;
    ActionApplicationShowAbout: TAction;
    ActionShowAbout1: TMenuItem;
    CreateaNewdatabase1: TMenuItem;
    N1: TMenuItem;
    Refreshdatabaseinformation1: TMenuItem;
    Compactsize1: TMenuItem;
    CheckdatabaseIntegrity1: TMenuItem;
    N2: TMenuItem;
    StartTransaction1: TMenuItem;
    CommitTransaction1: TMenuItem;
    RollbackTransaction1: TMenuItem;
    TsDatasetIndexes: TTabSheet;
    ActionListDatabase: TActionList;
    ActionDatabaseCreateNew: TAction;
    ActionDatabaseOpen: TAction;
    ActionDatabaseRefresh: TAction;
    ActionDatabaseClose: TAction;
    ActionDatabaseAttach: TAction;
    ActionDatabaseCheckIntegrity: TAction;
    ActionDatabaseCompactSize: TAction;
    PanelSqlStmt: TPanel;
    PanelSqlResult: TPanel;
    Splitter2: TSplitter;
    Panel6: TPanel;
    LabelSQLStmt: TLabel;
    Image1: TImage;
    Panel7: TPanel;
    Label24: TLabel;
    Image2: TImage;
    Panel8: TPanel;
    SbRunSQL: TSpeedButton;
    MemoSqlStmt: TMemo;
    ActionShowSQLPage: TAction;
    ActionDatabaseTransactionStart: TAction;
    ActionDatabaseTransactionCommit: TAction;
    ActionDatabaseTransactionRollback: TAction;
    DBGridSqlDirect: TDBGrid;
    DsSQLDirect: TDataSource;
    ActionDatabaseDetach: TAction;
    Attachadatabase1: TMenuItem;
    Detachadatabase1: TMenuItem;
    N3: TMenuItem;
    Panel9: TPanel;
    DBNavDataset: TDBNavigator;
    ImageDatasetReadOnly: TImage;
    LabelDatasetReadOnly: TLabel;
    Splitter: TSplitter;
    PanelDatasetToolbar: TPanel;
    ActionListDataset: TActionList;
    SbDatabaseOpen: TSpeedButton;
    SbDatabaseClose: TSpeedButton;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    SbDatabaseTransactionStart: TSpeedButton;
    SbDatabaseTransactionCommit: TSpeedButton;
    SbDatabaseTransactionRollback: TSpeedButton;
    Bevel10: TBevel;
    SbDatabaseShowSQLPage: TSpeedButton;
    ActionListIndexes: TActionList;
    ActionIndexCreateNew: TAction;
    ActionIndexRefresh: TAction;
    ActionIndexRename: TAction;
    ActionIndexDelete: TAction;
    Bevel13: TBevel;
    Bevel14: TBevel;
    Bevel16: TBevel;
    SbDatasetFilterOnOff: TSpeedButton;
    Bevel18: TBevel;
    LabelDatasetLocateRecordCount: TLabel;
    Panel5: TPanel;
    LabelCacheSize: TLabel;
    Label1: TLabel;
    LabelDbType: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    LabelDbFileSize: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    LabelDbComponentVersion: TLabel;
    Label11: TLabel;
    LabelDbSqliteLibVersion: TLabel;
    Label13: TLabel;
    LabelDbVersion: TLabel;
    Label15: TLabel;
    LabelDbKexiVersion: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    Label17: TLabel;
    Label19: TLabel;
    Label25: TLabel;
    EditDbCacheSize: TEdit;
    EditDbQueryTimeout: TEdit;
    CbDbReadOnly: TCheckBox;
    CbDbShowSystemObjects: TCheckBox;
    CBDbSmartOpen: TCheckBox;
    EditDbUserTag: TEdit;
    EditDbDefaultCacheSize: TEdit;
    CbDbCountChanges: TCheckBox;
    CbDbCaseSensitiveLike: TCheckBox;
    CbDbEmptyResultCallback: TCheckBox;
    CbDbFullColumnName: TCheckBox;
    EditDbPageSize: TEdit;
    EditDbEncoding: TEdit;
    Panel21: TPanel;
    SbDbApplyChanges: TSpeedButton;
    SbDbCancelChanges: TSpeedButton;
    EditDbTemporaryStorage: TEdit;
    EditDbSynchronous: TEdit;
    GridAttachedDatabases: TStringGrid;
    Panel34: TPanel;
    Bevel20: TBevel;
    Bevel21: TBevel;
    SbDatabaseRefresh: TSpeedButton;
    SbDatabaseCompactSize: TSpeedButton;
    SbDatabaseCheckIntegrity: TSpeedButton;
    Bevel9: TBevel;
    LabelRecordCount: TLabel;
    ActionDatabaseShowErrorLog: TAction;
    Showdatabaseerrorlog1: TMenuItem;
    N4: TMenuItem;
    ActionDatasetRefresh: TAction;
    SbDatasetRefresh: TSpeedButton;
    Bevel19: TBevel;
    Bevel22: TBevel;
    ActionDatabaseShowFieldTypesTranslationRules: TAction;
    Options1: TMenuItem;
    N5: TMenuItem;
    FieldTypesTranslationrules1: TMenuItem;
    ActionDatabaseShowCustomFieldDefs: TAction;
    CustomFieldDefs1: TMenuItem;
    ActionListTables: TActionList;
    ActionTableCreateNew: TAction;
    Tables1: TMenuItem;
    Createanewtable1: TMenuItem;
    TsFieldDefs: TTabSheet;
    Panel31: TPanel;
    Panel10: TPanel;
    PanelFieldDefs: TPanel;
    Label16: TLabel;
    ImageFalse: TImage;
    ImageCheck: TImage;
    PanelCreateStmt: TPanel;
    PanelSqlCreateStmt: TPanel;
    Label20: TLabel;
    Image6: TImage;
    MemoSqlCreateStmt: TMemo;
    PanelDefaultSelectStmt: TPanel;
    MemoSqlSelectStmt: TMemo;
    PanelSqlSelectStatement: TPanel;
    Label2: TLabel;
    Image8: TImage;
    Splitter3: TSplitter;
    ActionTableModify: TAction;
    ModifyTable1: TMenuItem;
    ActionTableDelete: TAction;
    ActionTableRename: TAction;
    ActionTableEmpty: TAction;
    RenameTable1: TMenuItem;
    N6: TMenuItem;
    EmptyTable1: TMenuItem;
    DeleteTable1: TMenuItem;
    ActionTableReindex: TAction;
    PopupMenuTables: TPopupMenu;
    Createanewtable2: TMenuItem;
    ModifyTable2: TMenuItem;
    RenameTable2: TMenuItem;
    N7: TMenuItem;
    EmptyTable2: TMenuItem;
    DeleteTable2: TMenuItem;
    ReindexTable1: TMenuItem;
    ReindexTable2: TMenuItem;
    PopupMenuDatabase: TPopupMenu;
    CreateaNewdatabase2: TMenuItem;
    Createanewtable3: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    Refreshdatabaseinformation2: TMenuItem;
    CompactSize2: TMenuItem;
    CheckdatabaseIntegrity2: TMenuItem;
    ActionListQueries: TActionList;
    ActionQueryCreateNew: TAction;
    ActionQueryModify: TAction;
    ActionQueryDelete: TAction;
    ActionQueryRename: TAction;
    PopupMenuQueries: TPopupMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem7: TMenuItem;
    Label4: TLabel;
    Shape1: TShape;
    Shape6: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape7: TShape;
    Shape8: TShape;
    SbDatabaseAttach: TSpeedButton;
    SbDatabaseDetach: TSpeedButton;
    CbDbVacuumType: TComboBox;
    Label27: TLabel;
    Shape9: TShape;
    LabelSQLStmtName: TLabel;
    ActionListSQLStmts: TActionList;
    ActionSQLStmtCreateNew: TAction;
    ActionSQLStmtDelete: TAction;
    ActionSQLStmtRename: TAction;
    PopupMenuSQLStmts: TPopupMenu;
    MenuItem9: TMenuItem;
    MenuItem10: TMenuItem;
    CreateanewSQLstatement1: TMenuItem;
    RenameSQLStatement1: TMenuItem;
    CreateanewSQLstatement2: TMenuItem;
    ActionTableSaveAsView: TAction;
    N10: TMenuItem;
    SaveTableasView1: TMenuItem;
    N11: TMenuItem;
    SaveTableasView2: TMenuItem;
    Queries1: TMenuItem;
    SQL1: TMenuItem;
    Views1: TMenuItem;
    Triggers1: TMenuItem;
    CreateanewSQLstatement3: TMenuItem;
    RenameSQLStatement2: TMenuItem;
    N12: TMenuItem;
    DeleteSQLstatement1: TMenuItem;
    ActionListViews: TActionList;
    ActionViewCreateNew: TAction;
    ActionViewDelete: TAction;
    ActionViewRename: TAction;
    ActionSQLExecute: TAction;
    PopupMenuViews: TPopupMenu;
    MenuItem8: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    RenameView1: TMenuItem;
    CreateanewView1: TMenuItem;
    RenameView2: TMenuItem;
    N13: TMenuItem;
    DeleteView1: TMenuItem;
    ActionListTriggers: TActionList;
    ActionTriggerCreateNew: TAction;
    ActionTriggerDelete: TAction;
    ActionTriggerRename: TAction;
    PopupMenuTriggers: TPopupMenu;
    MenuItem4: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    SbClosePanelSQLResult: TSpeedButton;
    TreeViewImageList: TImageList;
    Shape10: TShape;
    Shape11: TShape;
    ImageList: TImageList;
    ImageListEnabled: TImageList;
    ImageListDisabled: TImageList;
    ActionTriggerModify: TAction;
    ActionViewModify: TAction;
    ModifyTable3: TMenuItem;
    ActionSQLStmtModify: TAction;
    CompactSize3: TMenuItem;
    ModifyQuery1: TMenuItem;
    RenameQuery1: TMenuItem;
    N14: TMenuItem;
    DeleteQuery1: TMenuItem;
    N15: TMenuItem;
    Indexes1: TMenuItem;
    PopupMenuIndexes: TPopupMenu;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem19: TMenuItem;
    PopupMenuDatasets: TPopupMenu;
    MenuItem20: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem22: TMenuItem;
    MenuItem23: TMenuItem;
    MenuItem24: TMenuItem;
    MenuItem25: TMenuItem;
    MenuItem27: TMenuItem;
    MenuItem28: TMenuItem;
    N16: TMenuItem;
    LocateNext1: TMenuItem;
    LocateLast1: TMenuItem;
    N17: TMenuItem;
    Refresh1: TMenuItem;
    CreateanewQuery1: TMenuItem;
    CreateanewView2: TMenuItem;
    CreateanewTrigger1: TMenuItem;
    N18: TMenuItem;
    SQL2: TMenuItem;
    ActionDatabaseShowDatatypeOptions: TAction;
    ActionDatabaseShowDatatypeOptions1: TMenuItem;
    Bevel2: TBevel;
    SbDatabaseShowErrorLog: TSpeedButton;
    ActionTableCopy: TAction;
    ActionTableCopyToDatabase: TAction;
    CopyTable1: TMenuItem;
    CopyTabletoanotherdatabase1: TMenuItem;
    ActionTableSendToDatabase: TAction;
    ActionTableSendToDatabase1: TMenuItem;
    GridFieldDefs: TDrawGrid;
    ImagePrimaryKey: TImage;
    ImageAutoInc: TImage;
    ImageIndex: TImage;
    PanelDbGridDatasetData: TPanel;
    ImageListDbGrid: TImageList;
    ActionSQLStmtSaveToFile: TAction;
    ActionSQLStmtSaveToDatabase: TAction;
    PopupMenuSQLStmtText: TPopupMenu;
    ActionSQLStmtSaveAsToDatabase: TAction;
    ActionSQLStmtSaveAsView: TAction;
    ActionSQLStmtLoadFromFile: TAction;
    Loadfromfile1: TMenuItem;
    N19: TMenuItem;
    SavetoDatabase1: TMenuItem;
    SaveAstodatabase1: TMenuItem;
    N20: TMenuItem;
    SaveasView1: TMenuItem;
    SaveToFile1: TMenuItem;
    DBGridDatasetData: TDBGrid;
    ActionDatasetShowParserInfos: TAction;
    SbDatasetShowParserInfos: TSpeedButton;
    DBActionListDataset: TSqlitePassDBActionList;
    SbDatasetShowSortDialog: TSpeedButton;
    ActionDatasetShowSortDialog: TSqlitePassDatasetSort;
    SbDatasetFilterOnSelection: TSpeedButton;
    SbDatasetShowFilterDialog: TSpeedButton;
    SbDatasetShowLocateDialog: TSpeedButton;
    SbDatasetLocateFirst: TSpeedButton;
    SbDatasetLocatePrior: TSpeedButton;
    SbDatasetLocateNext: TSpeedButton;
    SbDatasetLocateLast: TSpeedButton;
    ActionDatasetFilterOnSelection: TSqlitePassDatasetFilterOnSelection;
    ActionDatasetShowFilterDialog: TSqlitePassDatasetFilter;
    ActionDatasetShowLocateDialog: TSqlitePassDatasetLocate;
    ActionDatasetLocateFirst: TSqlitePassDatasetLocateFirst;
    ActionDatasetLocatePrior: TSqlitePassDatasetLocatePrior;
    ActionDatasetLocateNext: TSqlitePassDatasetLocateNext;
    ActionDatasetLocateLast: TSqlitePassDatasetLocateLast;
    ActionDatasetSortAsc: TSqlitePassDatasetSortAsc;
    ActionDatasetSortDesc: TSqlitePassDatasetSortDesc;
    SbDatasetSortAsc: TSpeedButton;
    SbDatasetSortDesc: TSpeedButton;
    Bevel27: TBevel;
    Panel4: TPanel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Bevel8: TBevel;
    SbSQLDatasetFilterOnOff: TSpeedButton;
    Bevel15: TBevel;
    LabelSQLDatasetLocateRecordCount: TLabel;
    SbSQLDatasetRefresh: TSpeedButton;
    Bevel17: TBevel;
    SbSQLDatasetShowParserInfos: TSpeedButton;
    SbSQLDatasetShowSortDialog: TSpeedButton;
    SbSQLDatasetFilterOnSelection: TSpeedButton;
    SbSQLDatasetShowFilterDialog: TSpeedButton;
    SbSQLDatasetShowLocateDialog: TSpeedButton;
    SbSQLDatasetLocateFirst: TSpeedButton;
    SbSQLDatasetLocatePrior: TSpeedButton;
    SbSQLDatasetLocateNext: TSpeedButton;
    SbSQLDatasetLocateLast: TSpeedButton;
    SbSQLDatasetSortAsc: TSpeedButton;
    SbSQLDatasetSortDesc: TSpeedButton;
    Bevel23: TBevel;
    DBActionListSQLDataset: TSqlitePassDBActionList;
    ActionSQLDatasetSortAsc: TSqlitePassDatasetSortAsc;
    ActionSQLDatasetSortDesc: TSqlitePassDatasetSortDesc;
    ActionSQLDatasetSort: TSqlitePassDatasetSort;
    ActionSQLDatasetFilterOnSelection: TSqlitePassDatasetFilterOnSelection;
    ActionSQLDatasetShowFilterDialog: TSqlitePassDatasetFilter;
    ActionSQLDatasetShowLocateDialog: TSqlitePassDatasetLocate;
    ActionSQLDatasetLocateFirst: TSqlitePassDatasetLocateFirst;
    ActionSQLDatasetLocatePrior: TSqlitePassDatasetLocatePrior;
    ActionSQLDatasetLocateNext: TSqlitePassDatasetLocateNext;
    ActionSQLDatasetLocateLast: TSqlitePassDatasetLocateLast;
    ActionDatasetFilterOnOff: TSqlitePassDatasetFilterOnOff;
    Bevel24: TBevel;
    Bevel25: TBevel;
    ActionSQLDatasetFilterOnOff: TSqlitePassDatasetFilterOnOff;
    CbSQLQueryIsReadOnly: TCheckBox;
    Panel11: TPanel;
    Image3: TImage;
    Label23: TLabel;
    Label26: TLabel;
    DBNavigator1: TDBNavigator;
    SbShowDebugger: TSpeedButton;
    SbSaveDebuggerOutput: TSpeedButton;
    CopyTable2: TMenuItem;
    CopyTabletoanotherdatabase2: TMenuItem;
    SendTabletoanotherdatabase1: TMenuItem;
    PanelDatasetName: TPanel;
    PanelTv: TPanel;
    PanelStatus: TPanel;
    PanelDatabasePath: TPanel;
    PanelLibraryVersion: TPanel;
    PanelChrono: TPanel;
    PanelDatabaseType: TPanel;
    ImageDataset: TImage;
    ImageFieldsDefinitions: TImage;
    ImageListFieldDefs: TImageList;
    procedure CbDbReadOnlyChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtLoadPictureFromFileClick(Sender: TObject);
    procedure BtClearPictureClick(Sender: TObject);
    procedure BtSavePictureToFileClick(Sender: TObject);
    procedure ActionDatabaseOpenExecute(Sender: TObject);
    procedure CbShowGraphicClick(Sender: TObject);
    procedure CbShowMemoClick(Sender: TObject);
    procedure BtLoadMemoFromFileClick(Sender: TObject);
    procedure BtClearMemoClick(Sender: TObject);
    procedure BtSaveMemoToFileClick(Sender: TObject);
    procedure ComboBoxGraphicFieldsChange(Sender: TObject);
    procedure ActionDatabaseCloseExecute(Sender: TObject);
    procedure DbSettingChanged(Sender: TObject);
    procedure SbDbCancelChangesClick(Sender: TObject);
    procedure ActionApplicationQuitExecute(Sender: TObject);
    procedure ActionDatabaseRefreshExecute(Sender: TObject);
    procedure ActionApplicationShowAboutExecute(Sender: TObject);
    procedure ActionDatabaseCompactSizeExecute(Sender: TObject);
    procedure ActionShowSQLPageExecute(Sender: TObject);
    procedure ActionDatabaseTransactionStartExecute(Sender: TObject);
    procedure ActionDatabaseTransactionCommitExecute(Sender: TObject);
    procedure ActionDatabaseTransactionRollbackExecute(Sender: TObject);
    procedure ActionDatabaseAttachExecute(Sender: TObject);
    procedure ActionDatabaseDetachExecute(Sender: TObject);
    procedure ComboBoxMemoFieldsChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionDatabaseShowErrorLogExecute(Sender: TObject);
    procedure ActionDatasetRefreshExecute(Sender: TObject);
    procedure ActionDatabaseShowFieldTypesTranslationRulesExecute(Sender: TObject);
    procedure ActionDatabaseShowCustomFieldDefsExecute(Sender: TObject);
    procedure ActionDatabaseCreateNewExecute(Sender: TObject);
    procedure ActionTableCreateNewExecute(Sender: TObject);
    procedure ActionTableModifyExecute(Sender: TObject);
    procedure ActionTableRenameExecute(Sender: TObject);
    procedure ActionTableReindexExecute(Sender: TObject);
    procedure ActionTableDeleteExecute(Sender: TObject);
    procedure TsDatabaseShow(Sender: TObject);
    procedure CbDbShowSystemObjectsClick(Sender: TObject);
    procedure SbDbApplyChangesClick(Sender: TObject);
    procedure EditDbQueryTimeoutKeyPress(Sender: TObject; var Key: Char);
    procedure ActionTableEmptyExecute(Sender: TObject);
    procedure ActionSQLStmtCreateNewExecute(Sender: TObject);
    procedure ActionSQLStmtDeleteExecute(Sender: TObject);
    procedure ActionSQLStmtRenameExecute(Sender: TObject);
    procedure ActionTableSaveAsViewExecute(Sender: TObject);
    procedure ActionViewCreateNewExecute(Sender: TObject);
    procedure ActionViewDeleteExecute(Sender: TObject);
    procedure ActionSQLExecuteExecute(Sender: TObject);
    procedure SbClosePanelSQLResultClick(Sender: TObject);
    procedure ActionDatabaseCheckIntegrityExecute(Sender: TObject);
    procedure PopupMenusPopup(Sender: TObject);
    procedure DataSourcePlugDataChange(Sender: TObject; Field: TField);
    procedure ActionDatabaseShowDatatypeOptionsExecute(Sender: TObject);
    procedure ActionTableCopyExecute(Sender: TObject);
    procedure ActionTableCopyToDatabaseExecute(Sender: TObject);
    procedure GridFieldDefsDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ActionSQLStmtSaveToFileExecute(Sender: TObject);
    procedure ActionSQLStmtSaveToDatabaseExecute(Sender: TObject);
    procedure ActionSQLStmtSaveAsToDatabaseExecute(Sender: TObject);
    procedure ActionSQLStmtSaveAsViewExecute(Sender: TObject);
    procedure ActionSQLStmtLoadFromFileExecute(Sender: TObject);
    procedure GridFieldDefsMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure ActionDatasetShowParserInfosExecute(Sender: TObject);
    procedure DBGridDatasetDataTitleClick(Column: TColumn);
    procedure DBGridSqlDirectTitleClick(Column: TColumn);
    procedure SbShowDebuggerClick(Sender: TObject);
    procedure SbSaveDebuggerOutputClick(Sender: TObject);
    procedure DBTreeViewSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
    procedure PanelTvResize(Sender: TObject);
  private
    FilterTextFromDialogFilter: String;
    MRUFileList: TStringList;
    ToolboxDbAvailable: Boolean;
    ActionsNeedUpdate: Boolean;

    { UTF8 Support }
    {$IFDEF NeedUTF8Vcl}
    procedure CheckForUTF8Support;
    {$ENDIF NeedUTF8Vcl}

    {$IFNDEF FPC}
    Procedure InitMenuImages;
    function GetMenuItemImage(MenuItem: TMenuItem): Boolean;
    Procedure RefreshMenuImages;
    {$ENDIF}
    Procedure InitToolbarImages;
    Procedure RefreshActions(NeedUpdate: Boolean = False);
    Procedure RefreshStatusBar;

    { --- Indexes --- }
    procedure RefreshIndexList;
    
    { --- Database --- }
    procedure OpenDatabaseFile(FileName: String = '');
    procedure ShowDatabaseInfos;
    function DatabaseTypeAsString: String;
    function DatabaseAutoVaccumAsString: String;

    { --- Datasets --- }
    procedure ShowDatasetInfos;

    { MRU Files }
    procedure LoadMRUFiles;
    procedure SaveMRUFiles;
    procedure AddNewMRUFile(FileName: String);
    procedure MRUFileOpen(Sender: TObject);
    procedure UpdateMRUFiles;

    procedure ShowDbItem;
    { Idle Handler }
    procedure ApplicationIdleHandler(Sender: TObject; var Done: Boolean);
  public
    DBTreeView: TSPVTDBTreeView;
    
    { Db and Dataset selected by user }
    Db: TSqlitePassDatabase;
    Dataset: TSqlitePassDataset;

    { Dataset used to execute direct SQL on user demand }
    SQLDirectDataset: TSqlitePassDataset;

    { Db and Dataset to store program settings }
    DbSettings: TSqlitePassDatabase;
    DatasetSettings: TSqlitePassDataset;
  end;

var
  MainForm: TMainForm;

implementation

 {$IFNDEF FPC}
  {$R *.DFM}
 {$ENDIF}

Uses SqlitePassSortByDialog, SqlitePassCreateNewIndex, SqlitePassRenameItem,
  SqlitePassLocateDialog, SqlitePassFiltersDialog, SqlitePassErrorLogDialog,
  SqlitePassDataTypesDialog, SqlitePassCustomFieldDefsDialog,
  SqlitePassCreateNewDatabaseDialog, SqlitePassCreateTableDialog,
  SqlitePassDataTypeOptions, SqlitePassParserDialog;


{$IFDEF NeedUTF8Vcl}
procedure TMainForm.CheckForUTF8Support;
const
 UTF8VclTestText = 't'#$D1#$96#$C3#$B4#$EF#$A7#$A7#$C3#$A0#$6C#$D1#$96#$7A#$C3#$A6#$74#$E2#$98#$BA#$6E2;
var
 TestLabel: TLabel;
begin
 TestLabel := TLabel.Create(Self);
Try
 TestLabel.Caption := UTF8VclTestText;
 if TestLabel.Caption <> UTF8VclTestText
    then ShowMessage('Unicode support is NOT activated !');
finally
 TestLabel.Free;
end;
end;
{$ENDIF NeedUTF8Vcl}


{ Creates / Destroys the Main Form }

procedure TMainForm.FormCreate(Sender: TObject);
begin
{$IFDEF NeedUTF8Vcl}
CheckForUTF8Support;
{$ENDIF NeedUTF8Vcl}

{ Utility Rename Database Item form }
FormRenameItem := TSqlitePassFormRenameItem.Create(Self);

{ Db and Dataset to store program settings }
DbSettings := TSqlitePassDatabase.Create(Self);
DbSettings.DatatypeOptions.LoadOptions := [soManual];
DbSettings.DatatypeOptions.SaveOptions := [soManual];
DbSettings.Database := 'SQLiteToolbox.db3';
DatasetSettings := TSqlitePassDataset.Create(Self);
DatasetSettings.Database := DbSettings;

{ Db and Dataset selected by user }
Db := TSqlitePassDatabase.Create(Self);
Db.Options.LogErrors := True;
Dataset := TSqlitePassDataset.Create(Self);
Dataset.LocateSmartRefresh := True;
Dataset.LookupSmartRefresh := True;
Dataset.Database := Db;

{ Dataset used to execute direct SQL on user demand }
SQLDirectDataset := TSqlitePassDataset.Create(Self);
SQLDirectDataset.Database := Db;
SQLDirectDataset.ReadOnly := False;
dsSQLDirect.DataSet := SQLDirectDataset;

{ MRU Files }
MRUFileList := TStringList.Create;
ToolboxDbAvailable := True;

try
LoadMRUFiles;
except
On Exception do
   begin
   ToolboxDbAvailable := False;
   MessageDlg('The database "SqlitePassToolBox.db3" was not found in program directory or cannot be opened.'
              +' Please Reinstall this file in the program directory.', mtWarning, [mbOk], -1);
   end;
end;

{ TreeView }
DBTreeView := TSPVTDBTreeView.Create(PanelTv);
With DBTreeview do
  begin
  Parent := PanelTv;
  Database := Db;
  ImageList := TreeViewImageList;
  OnSelectCell := Self.DBTreeViewSelectCell;
  end;

{ Indexes }
SqlitePassIndexDefsDialog := TSqlitePassIndexDefsDialog.Create(Self);
With SqlitePassIndexDefsDialog do
     begin
     BorderIcons:=[];
     BorderStyle:=bsNone;
     Parent := TsDatasetIndexes;
     Align:=alClient;
     Visible := True;
     end;

{ Init Screen, Toolbars, Actions etc...}
PageControl.Visible := False;
PanelTv.Visible := False;

{$IFNDEF FPC}
InitMenuImages;
CbShowGraphic.Checked := True;
{$ELSE}
CbShowGraphic.Checked := False;
{$ENDIF}

InitToolBarImages;

GridFieldDefs.ColWidths[0] := 140;

Application.OnIdle := ApplicationIdleHandler;
ActionsNeedUpdate := True;
WindowState := wsMaximized;

{ Debugger }
{$IFDEF DEBUG_SQLITEPASS}
SbShowDebugger.Visible := Assigned(Db.debugger);
SbSaveDebuggerOutput.Visible := Assigned(Db.debugger);
{$ENDIF}
end;

procedure TMainForm.CbDbReadOnlyChange(Sender: TObject);
begin
  Db.ReadOnly := CbDbReadOnly.Checked;
end;


procedure TMainForm.FormDestroy(Sender: TObject);
begin
{ No need to free Db or datasets since the owner will do it automatically }
MRUFileList.Free;
FormRenameItem.Free;
end;

{ Terminates the application }

procedure TMainForm.ActionApplicationQuitExecute(Sender: TObject);
begin
Application.Terminate;
end;

{ Opens / Closes a database }

procedure TMainForm.ActionDatabaseOpenExecute(Sender: TObject);
begin
OpenDatabaseFile;
end;

procedure TMainForm.OpenDatabaseFile(FileName: String = '');
begin
if (FileName = '') then
   if OpenFileDialog.Execute and (OpenFileDialog.FileName <> '')
      then FileName := OpenFileDialog.FileName
      else exit;

if FileName <> '' then
   begin
   Db.Close;
   Db.Database := FileName;
   Db.SmartOpen := False;
   Db.Open;
   if Db.Connected then
      begin
      AddNewMRUFile(Db.Database);
      UpdateMRUFiles;
      PanelTv.Visible := True;
      DBTreeview.RefreshItems;
      DBTreeView.SelectedIndex := 0;
      ShowDbItem;
      ActionsNeedUpdate := True
      end;
   end;
end;

procedure TMainForm.ActionDatabaseCloseExecute(Sender: TObject);
begin
if db.Engine.Transaction.Level > 0 then
   begin
   MessageDlg('The database cannot be closed because a transaction is still running.'
              +' Please commit or rollback this transaction before leaving.', mtWarning, [mbOk], -1);
   exit;
   end;

if Db.DatabaseError.ErrorCount > 0 then
   if MessageDlg(IntToStr(Db.DatabaseError.ErrorCount) + ' error(s) are logged in the database errors log. '
        +' Do you want to watch the errors before leaving ?', mtInformation, [mbYes, mbNo], -1) = mrYes
           then ActionDatabaseShowErrorLogExecute(Self);

Db.Close;
PageControl.Visible := False;
PanelTv.Visible := False;
SaveMRUFiles;
ActionsNeedUpdate := True;
end;


{ Displays Databases parts in a Treeview }

procedure TMainForm.ShowDbItem;
begin
If Not Assigned(DBTreeView.SelectedItem)
   then Exit;

Try
{ Database is closed ? }
if Not Db.Connected then
   begin
   PageControl.Visible := False;
   DBTreeView.PopupMenu := PopupMenuDatabase;
   Exit;
   end;

{ Popup Menus }
Case DBTreeView.SelectedItem.ItemType of

     itDatabase    : DBTreeView.PopupMenu := PopupMenuDatabase;
     itTable,
     itTableSystem : DBTreeView.PopupMenu := PopupMenuTables;
     itQuery       : DBTreeView.PopupMenu := PopupMenuQueries;
     itView        : DBTreeView.PopupMenu := PopupMenuViews;
     itTrigger     : DBTreeView.PopupMenu := PopupMenuTriggers;
     itSQL..itSqlOthers : DBTreeView.PopupMenu := PopupMenuSQLStmts;
     end;

{ Database }
if DBTreeView.SelectedItem.ItemType = itDatabase
   then begin
        ShowDatabaseInfos;
        PageControl.Pages[0].Tabvisible := True;
        PageControl.Pages[1].Tabvisible := False;
        PageControl.Pages[2].Tabvisible := False;
        PageControl.Visible := True;
        Exit;
        end
   else if DBTreeView.SelectedItem.HasChildren then
           begin
           PageControl.Visible := False;
           Exit;
           end;

{ Show Dataset }
if Not (DBTreeView.SelectedItem.HasChildren)
   and (Assigned(DBTreeView.SelectedItem.Parent))
   and (DBTreeView.SelectedItem.Parent.ItemType <> itDatabase)
   and (DBTreeView.SelectedItem.ItemType in [itTable, itTableSystem, itQuery, itView, itSQLSelect]) then
   begin
   ShowDatasetInfos;
   PageControl.Pages[0].Tabvisible := False;
   PageControl.Pages[1].Tabvisible := True;
   PageControl.Visible := True;
   { SQL Select }
   PageControl.Pages[2].Tabvisible := (DBTreeView.SelectedItem.ItemType = itSqlSelect);
   { Indexes Tab }
   PageControlDataset.Pages[2].Tabvisible := Not (DBTreeView.SelectedItem.ItemType in [itQuery, itView]);
   Exit;
   end;

{ Show SQL }
if DBTreeView.SelectedItem.ItemType in [itSql, itSqlSelect, itSqlCreate, itSqlCreateTable, itSqlUpdate,
                                        itSqlInsert, itSqlDelete, itSqlOthers] then
   begin
   PageControl.Pages[0].Tabvisible := False;
   PageControl.Pages[1].Tabvisible := (DBTreeView.SelectedItem.ItemType = itSqlSelect);
   PageControl.Pages[2].Tabvisible := True;
   PageControl.Visible := True;
   MemoSQLStmt.Clear;
   LabelSQLStmtName.Caption := DBTreeView.SelectedItem.Caption;
   MemoSQLStmt.Lines.Text := Db.SQLStmtDefs.SQLStmtByName(DBTreeView.SelectedItem.Caption).SQL;
   SQLDirectDataset.Close;
   PanelSQLResult.Visible := False;
   end;
finally
ActionsNeedUpdate := True;
end;
end;


{ Displays infos on current database }

procedure TMainForm.ActionDatabaseRefreshExecute(Sender: TObject);
begin
   Db.RefreshDefinitions;
   DBTreeView.RefreshItems;
   ShowDatabaseInfos;
end;

procedure TMainForm.ActionDatabaseCompactSizeExecute(Sender: TObject);
begin
ShowMessage(IntToStr(Db.Compact) + ' octets have been freed from the database : '+ Db.Database);
ActionDatabaseRefreshExecute(Sender);
end;


{ Loads / Shows / Saves images (Blobs) }

procedure TMainForm.BtLoadPictureFromFileClick(Sender: TObject);
begin
if OpenPictureDialog.Execute
   then begin
        Dataset.Edit;
        TBlobField(DbImage.Field).LoadFromFile(OpenPictureDialog.Filename);
        end;
end;

procedure TMainForm.BtClearPictureClick(Sender: TObject);
begin
 Dataset.Edit;
 DbImage.Field.Clear;
end;

procedure TMainForm.BtSavePictureToFileClick(Sender: TObject);
begin
If SavePictureDialog.Execute
   then TBlobField(DbImage.Field).SaveToFile(SavePictureDialog.Filename);
end;

procedure TMainForm.CbShowGraphicClick(Sender: TObject);
begin
if cbShowGraphic.Checked
 then ComboBoxGraphicFieldsChange(Sender);
end;

procedure TMainForm.ComboBoxGraphicFieldsChange(Sender: TObject);
var
F: TField;
begin
if ComboBoxGraphicFields.Text = '' then exit;
F := Dataset.FieldByName(ComboBoxGraphicFields.Text);
if (F <> nil) and CbShowGraphic.Checked
   then begin
        if F.DataType in [ftBlob, ftGraphic] then
           begin
           DbImage.DataField := ComboBoxGraphicFields.Text;
           {$IFDEF FPC }
           DbImage.DataSource := DataSourcePlug;
           {$ENDIF}
           end;
        end
//        else DbImage.DataField := '';
end;


{ Loads / Shows / Saves Memos (Blobs) }

procedure TMainForm.CbShowMemoClick(Sender: TObject);
begin
if cbShowMemo.Checked
   then ComboBoxMemoFieldsChange(Sender);
end;

procedure TMainForm.BtLoadMemoFromFileClick(Sender: TObject);
begin
if OpenFileDialog.Execute
   then begin
        Dataset.Edit;
        TMemoField(DbMemo.Field).LoadFromFile(OpenFileDialog.FileName);
        end;
end;

procedure TMainForm.BtClearMemoClick(Sender: TObject);
begin
 Dataset.Edit;
 TBlobField(DbMemo.Field).Clear;
end;

procedure TMainForm.BtSaveMemoToFileClick(Sender: TObject);
begin
If SaveFileDialog.Execute
   then TBlobField(DbMemo.Field).SaveToFile(SaveFileDialog.Filename);
end;


procedure TMainForm.DbSettingChanged(Sender: TObject);
begin
 SbDbApplyChanges.Enabled := True;
 SbDbCancelChanges.Enabled := True;
end;

procedure TMainForm.SbDbCancelChangesClick(Sender: TObject);
begin
if MessageDlg('Do you really want to undo all the changes ? ', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
   SbDbApplyChanges.Enabled := False;
   SbDbCancelChanges.Enabled := False;
   ActionDatabaseRefreshExecute(Sender);
   end;
end;


procedure TMainForm.ActionApplicationShowAboutExecute(Sender: TObject);
begin
ShowMessage('SQLiteToolBox. SQLitePass Components Demo Program. Version : '+ Db.VersionInfo.Component + '.'+ #13#10 +
            'This program is FREEWARE, under GNU Lesser General Public License. Enjoy !' + #13#10 +
            'Icon sets : Silk icon set 1.3 by Mark James (http://www.famfamfam.com/lab/icons/silk/)'+ #13#10 +
            'Contributor : Luc David (luckylazarus@free.fr)');

end;

procedure TMainForm.ActionShowSQLPageExecute(Sender: TObject);
begin
//Tv.Selected := SQLNode;
end;

procedure TMainForm.ActionDatabaseTransactionStartExecute(Sender: TObject);
begin
Db.Engine.Transaction.Start;
ActionsNeedUpdate := True;
end;

procedure TMainForm.ActionDatabaseTransactionCommitExecute(
  Sender: TObject);
begin
Db.Engine.Transaction.Commit;
ActionsNeedUpdate := True;
end;

procedure TMainForm.ActionDatabaseTransactionRollbackExecute(
  Sender: TObject);
begin
Db.Engine.Transaction.Rollback;
ActionsNeedUpdate := True;
end;

procedure TMainForm.ActionDatabaseAttachExecute(Sender: TObject);
begin
if OpenFileDialog.Execute then
   begin
   Db.AttachDatabase(OpenFileDialog.FileName,'');
   DBTreeView.RefreshItems;
   end;
end;

procedure TMainForm.ActionDatabaseDetachExecute(Sender: TObject);
begin
Try
 Db.DetachDatabase(GridAttachedDatabases.Cells[0,GridAttachedDatabases.row]);
finally
DBTreeView.RefreshItems;
end;
end;

{ Displays database information on the Database TabSheet }
procedure TMainForm.ShowDatabaseInfos;
var
i: integer;
//f: TFileStream;
begin
if not Db.Connected then exit;
//Tv.Selected := DatabaseNode;
{ Infos }
LabelDbType.Caption := DatabaseTypeAsString;
{ Db Size }
(*Try
Try
//f := TFileStream.Create(Db.Database, fmOpenRead or fmShareDenyNone);
//LabelDbFileSize.Caption := IntToStr(F.Size) + ' octets';
Except
//LabelDbFileSize.Caption := 'Unknown size';
end;
finally
//f.free;
end;*)
{ Other Info }
EditDbQueryTimeout.Text := IntToStr(Db.QueryTimeout);
EditDbUserTag.Text := IntToStr(Db.UserTag);
CbDbShowSystemObjects.Checked := Db.ShowSystemObjects;
CbDbReadOnly.Checked := Db.ReadOnly;
CbDbSmartOpen.Checked := Db.SmartOpen;

{ Versions }
LabelDbComponentVersion.Caption := Db.VersionInfo.Component;
LabelDbSqliteLibVersion.Caption := Db.VersionInfo.SqliteLibrary;
LabelDbVersion.Caption := IntToStr(Db.VersionInfo.Schema);
LabelDbKexiVersion.Caption := Db.VersionInfo.DbVersion;

{ Options }
EditDbCacheSize.Text := IntToStr(Db.Options.CacheSize);
CbDbVacuumType.ItemIndex := Db.Options.AutoVacuum;
CbDbCountChanges.Checked := Db.Options.CountChanges;
CbDbCaseSensitiveLike.Checked := Db.Options.CaseSensitiveLike;
CbDbEmptyResultCallback.Checked := Db.Options.EmptyResultCallback;
CbDbFullColumnName.Checked := Db.Options.FullColumnNames;
EditDbPageSize.Text := IntToStr(Db.Options.PageSize);
EditDbEncoding.Text := Db.Options.GetEncodingAsString(Db.Options.Encoding);
EditDbTemporaryStorage.Text := '';
{ Synchronous }

{ --- Display Attached Databases Infos ---  }
With GridAttachedDatabases do
  begin
  cells[0,0] := 'Alias name';
  cells[1,0] := 'Database';
  { Clear Grid }
  for i := 1 to 9 do  // should be 1 to 10 -> Lazarus TVirtualGrid.GetCells(Col, Row: Integer) bug ?
    begin
    Cells[0,i] := '';
    Cells[1,i] := '';
    end;
  { Refresh Grid }
  if (Db.Databases.count > 0) then
  begin
  for i := 0 to Pred(Db.Databases.count) do
    begin
    Cells[0,i+1] := Db.Databases[i].AliasName;
    Cells[1,i+1] := Db.Databases[i].Database;
    end;
  end;
  end;
end;


procedure TMainForm.ShowDatasetInfos;
var
i: Integer;
MyTableDef: TSqlitePassTableDef;
GraphicFieldAvailable, MemoFieldAvailable: Boolean;
begin
With MainForm do
begin
  PageControl.ActivePage := TsDataset;
  PanelDatasetName.Caption := ' Dataset : ' + DBTreeView.SelectedItem.Caption;
  {$IFDEF FPC }
  DbImage.DataSource := nil; // Otherwise DbImage.DataField := '' raise exception 'Field '' not found wit FPC
  {$ENDIF}
  DbImage.DataField := '';
  ComboBoxGraphicFields.Clear;
  ComboBoxGraphicFields.Text := '';
  {$IFDEF FPC }
  DbMemo.DataSource := nil; // Otherwise DbImage.DataField := '' raise exception 'Field '' not found wit FPC
  {$ENDIF}
  DbMemo.DataField := '';
  ComboBoxMemoFields.Clear;
  ComboBoxMemoFields.Text := '';

  { Reset Filter Action Hint}
  FilterTextFromDialogFilter := '';

  { Show Data }
  With Dataset do
  begin
  Close;
  ReadOnly := False;
  Database := Db;
  Try
  DatasetName := DBTreeView.SelectedItem.Caption;
  Open;
  Except
  ActionsNeedUpdate := True;
(*  if (Node = SQLNode) or (Node.Parent = SQLNode) or (Node.Parent.Parent = SQLNode) then begin
    begin
    PageControl.Pages[0].Tabvisible := False;
    PageControl.Pages[1].Tabvisible := False;
    PageControl.Pages[2].Tabvisible := True;
    PageControlDataset.ActivePage := TsSQL;
    LabelSQLStmtName.Caption := Node.Text;
    MemoSQLStmt.Lines.Text := Db.SQLStmtDefs.SQLStmtByName(Node.Text).SQL;
    MemoSQLStmt.SetFocus;
    PanelSQLResult.Visible := False;
    SQLDirectDataset.Close;
    Raise;
    end;
  end;*)
  end;

  MemoSqlCreateStmt.Clear;
  MyTableDef := Db.TableDefs.FindTable(DBTreeView.SelectedItem.Caption);
  If Assigned(MyTableDef)
     then MemoSqlCreateStmt.Lines.Text := MyTableDef.Sql;

  MemoSqlSelectStmt.Clear;
  MemoSqlSelectStmt.Lines.Text := SQL.Text;

  if ReadOnly or not CanModify
     then begin
     DbNavDataset.VisibleButtons := [nbFirst, nbPrior, nbNext, nbLast, nbRefresh];
     DbGridDatasetData.Color := $00E2E2E2;
     DbGridDatasetData.Font.Color := clGray;
     DbGridDatasetData.Options := [DgTitles, dgColumnResize,dgColLines,dgRowLines,dgAlwaysShowSelection,dgRowSelect];
     ImageDatasetReadOnly.Visible := True;
     LabelDatasetReadOnly.Visible := True;
     end
     else begin
     DbNavDataset.VisibleButtons := [nbFirst, nbPrior, nbNext, nbLast, nbInsert, nbEdit, nbDelete, nbPost, nbCancel, nbRefresh];
     DbGridDatasetData.Color := clWhite;
     DbGridDatasetData.Font.Color := clNavy;
     DbGridDatasetData.Options := [dgTitles, dgEditing, dgIndicator, dgColumnResize,dgColLines,dgRowLines,dgTabs,dgAlwaysShowSelection,dgConfirmDelete];
     {$IFNDEF FPC} { the dgAlwaysShowEditor option disables DbActions with FPC...}
     DbGridDatasetData.Options := DbGridDatasetData.Options + [dgAlwaysShowEditor];
     {$ENDIF}
     ImageDatasetReadOnly.Visible := False;
     LabelDatasetReadOnly.Visible := False;
     end;
  end;
  DataSourcePlug.DataSet := Dataset;

  { --- Display FieldDefs Infos ---  }
  GridFieldDefs.ColCount := Dataset.SQLSelectStmt.FieldDefs.Count + 1;
  GridFieldDefs.Refresh;

  { Display IndexDefs Infos }
  RefreshIndexList;

  { Display available Blobs fields }
  For i := 0 to Pred(Dataset.Fields.Count) do
    Case Dataset.Fields[i].Datatype of
         ftGraphic : ComboBoxGraphicFields.Items.Add(Dataset.Fields[i].FieldName);

         ftMemo,
         ftFmtMemo : ComboBoxMemoFields.Items.Add(Dataset.Fields[i].FieldName);
         end;

  { Is there any graphic field in dataset ? }
  GraphicFieldAvailable := (ComboBoxGraphicFields.Items.Count > 0);
  if GraphicFieldAvailable then
     begin
     ComboBoxGraphicFields.Text := ComboBoxGraphicFields.Items[0];
     ComboBoxGraphicFieldsChange(Self);
     end;
  CbShowGraphic.Enabled := GraphicFieldAvailable;
  ComboBoxGraphicFields.Enabled := GraphicFieldAvailable;
  DbImage.Enabled := GraphicFieldAvailable;
  BtLoadPictureFromFile.Enabled := GraphicFieldAvailable;
  BtClearPicture.Enabled := GraphicFieldAvailable;
  BtSavePictureToFile.Enabled := GraphicFieldAvailable;

  { Is there any memo field in dataset ? }
  MemoFieldAvailable := (ComboBoxMemoFields.Items.Count > 0);
  if MemoFieldAvailable then
     begin
     ComboBoxMemoFields.Text := ComboBoxMemoFields.Items[0];
     ComboBoxMemoFieldsChange(Self);
     end;
  CbShowMemo.Enabled := MemoFieldAvailable;
  ComboBoxMemoFields.Enabled := MemoFieldAvailable;
  DbImage.Enabled := MemoFieldAvailable;
  BtLoadMemoFromFile.Enabled := MemoFieldAvailable;
  BtClearMemo.Enabled := MemoFieldAvailable;
  BtSaveMemoToFile.Enabled := MemoFieldAvailable;

  { Refresh Status Bar }
  RefreshStatusBar;
end;
end;


procedure TMainForm.ComboBoxMemoFieldsChange(Sender: TObject);
var
F: TField;
begin
if ComboBoxMemoFields.Text = '' then exit;
F := Dataset.FieldByName(ComboBoxMemoFields.Text);
if (F <> nil) and CbShowMemo.Checked
   then begin
        if F.DataType = ftMemo then
           begin
           DbMemo.DataField := ComboBoxMemoFields.Text;
           {$IFDEF FPC }
           DbMemo.DataSource := DataSourcePlug;
           {$ENDIF}
           end;
        end
//        else DbMemo.DataField := '';
end;


{ --- Dataset Index --- }

{ Indexes Management }

procedure TMainForm.RefreshIndexList;
begin
 SqlitePassIndexDefsDialog.Dataset := Self.Dataset;
end;

function TMainForm.DatabaseTypeAsString: String;
begin
Case Db.DatabaseType of
     dbtSqlitePass  : Result := 'SQLitePass';
     dbtKexi        : Result := 'Kexi';
     dbtSqliteAdmin : Result := 'SQLite Administrator';
     dbtSqlite4Fpc  : Result := 'SQLite4FPC';
     dbtSqliteExpert: Result := 'SQLite Expert';
     else             Result := 'Unknown...';
     end;
end;

function TMainForm.DatabaseAutoVaccumAsString: String;
begin
Case Db.Options.AutoVacuum of
     0 : Result := 'Manual';
     1 : Result := 'Auto-Full';
     2 : Result := 'Auto-Incremental';
     end;
end;


{ MRU Files }
procedure TMainForm.LoadMRUFiles;
begin
Try
DbSettings.Open;
DatasetSettings.DatasetName := 'MRUFiles';
DatasetSettings.Open;
MRUFileList.Text:= DatasetSettings.FieldByName('Files').AsString;
finally
DbSettings.Close;
UpdateMRUFiles;
end;
end;

procedure TMainForm.SaveMRUFiles;
begin
if ToolboxDbAvailable and (MRUFileList.Count > 0) then
   begin
   DbSettings.Open;
   With DatasetSettings do
        begin
        DatasetName := 'MRUFiles';
        Open;
        First;
        Edit;
       {$IFDEF FPC}
        DatasetSettings.FieldByName('Files').Text := MRUFileList.Text;
       {$ELSE}
        DatasetSettings.FieldByName('Files').Assign(MRUFileList);
       {$ENDIF}
        Post;
        Close;
        end;
   DbSettings.Close;
   end;
end;

procedure TMainForm.AddNewMRUFile(FileName: String);
var
IndexOf: Integer;
begin
IndexOf := MRUFileList.IndexOf(FileName);
  if IndexOf = -1
     then MRUFileList.Insert(0, FileName)
     else MRUFileList.Exchange(0, IndexOf);

  if MRUFileList.Count > MaxMRUFilesCount
     then MRUFileList.Delete(Pred(MRUFileList.Count));
end;


procedure TMainForm.UpdateMRUFiles;
var
  i: Integer;
  NewItem: TMenuItem;
begin
  { Clear Menu Items }
  While MainMenu.Items[0].Count > MenuDatabaseItemsCount
        do MainMenu.Items[0].Delete(Pred(MainMenu.Items[0].Count));

  if MRUFileList.Count > 0 then
     begin
     { Menu Items }
     NewItem := TMenuItem.Create(MainMenu);
     NewItem.Caption := '-';
     MainMenu.Items[0].Add(NewItem);

     for i := 0 to Pred(MRUFileList.Count) do
         begin
         NewItem := TMenuItem.Create(MainMenu);
         NewItem.Caption := MRUFileList.Strings[i];
         //NewItem.ShortCut := TextToShortCut('&' + IntToStr(i+1));
         NewItem.OnClick := MRUFileOpen;
         if FileExists(MRUFileList.Strings[i])
            then MainMenu.Items[0].Add(NewItem);
         end;

     end;
end;

procedure TMainForm.MRUFileOpen(Sender: TObject);
var
FileName: String;
begin
FileName := (TMenuItem(Sender).Caption);
{ Caption returns leading blanck space so we remove it (D4) }
OpenDatabaseFile(Trim(FileName));
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
SaveMRUFiles;
DbSettings.Close;
Db.Close;
end;

procedure TMainForm.ActionDatabaseShowErrorLogExecute(Sender: TObject);
begin
SqlitePassErrorLogDlg := TSqlitePassErrorLogDlg.Create(Self, Db);
SqlitePassErrorLogDlg.ShowModal;
SqlitePassErrorLogDlg.Free;
ActionsNeedUpdate := True;
end;

procedure TMainForm.ActionDatasetRefreshExecute(Sender: TObject);
begin
 Dataset.Refresh;
end;

procedure TMainForm.ActionDatabaseShowFieldTypesTranslationRulesExecute(Sender: TObject);
begin
SqlitePassDatatypesDlg := TSqlitePassDatatypesDlg.Create(Db);
SqlitePassDatatypesDlg.ShowModal;
SqlitePassDatatypesDlg.Free;
//TvChange(Self, Tv.Selected);
end;

procedure TMainForm.ActionDatabaseShowCustomFieldDefsExecute(
  Sender: TObject);
begin
SqlitePassCustomFieldDefsDlg := TSqlitePassCustomFieldDefsDlg.Create(Db);
SqlitePassCustomFieldDefsDlg.ShowModal;
SqlitePassCustomFieldDefsDlg.Free;
//TvChange(Self, Tv.Selected);
end;

procedure TMainForm.ActionDatabaseCreateNewExecute(Sender: TObject);
var
NewDb: String;
begin
NewDb := '';
SqlitePassCreateNewDatabaseDlg := TSqlitePassCreateNewDatabaseDlg.Create(Self);
if SqlitePassCreateNewDatabaseDlg.ShowModal = mrOk then
   begin
   if MessageDlg('Do you want to open the new created database : '
      + SqlitePassCreateNewDatabaseDlg.TEditDbFileFullPath.Text + ' ?',
      mtConfirmation, [mbYes, mbNo], -1) = mrYes
      then NewDb := SqlitePassCreateNewDatabaseDlg.TEditDbFileFullPath.Text;
   end;
SqlitePassCreateNewDatabaseDlg.Free;
if NewDb <> '' then
   begin
   ActionDatabaseCloseExecute(Self);
   OpenDatabaseFile(NewDb);
   end;
end;

procedure TMainForm.ActionTableCreateNewExecute(Sender: TObject);
begin
SqlitePassCreateTableDlg := TSqlitePassCreateTableDlg.Create(Self, Db);
Try
if SqlitePassCreateTableDlg.ShowModal = mrOk then
   begin
   Db.TableDefs.CreateTable(SqlitePassCreateTableDlg.SQL);
   ShowMessage('Table ' + SqlitePassCreateTableDlg.EditTableName.Text + ' was created.');
   ActionDatabaseRefreshExecute(Sender);
   DBTreeView.SelectByName(SqlitePassCreateTableDlg.EditTableName.Text, [itTable]);
   end;
finally
SqlitePassCreateTableDlg.Free;
end;
end;

procedure TMainForm.ActionTableModifyExecute(Sender: TObject);
var
OriginalTableName, BackupTableName, FieldNames: String;
TableDef: TSqlitePassTableDef;
FieldDef: TSqlitePassTableFieldDef;
i: Integer;
begin
ShowMessage('This feature is not fully implemented. Some fields information are not correctly retreived from table. '+
            'You will have to complete it manually or directly edit the SQL statement...');

SqlitePassCreateTableDlg := TSqlitePassCreateTableDlg.Create(Self, Db);
Try
SqlitePassCreateTableDlg.BtOk.Caption := 'Modify Table';
//OriginalTableName := Tv.Selected.Text;
TableDef := Db.TableDefs.TableByName(OriginalTableName);
SqlitePassCreateTableDlg.EditTableName.Text := OriginalTableName;
SqlitePassCreateTableDlg.EditTableName.Enabled := False;

for i := 0 to Pred(TableDef.FieldDefs.Count) do
    begin
    FieldDef := TableDef.FieldDefs[i];
    TEdit(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('EditFieldName')).Text := FieldDef.FieldName;
    TComboBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbDataType')).ItemIndex := TComboBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbDataType')).Items.IndexOf(Lowercase(FieldDef.NativeDataType));
    TEdit(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('EditSize')).Text := IntToStr(FieldDef.Size);
    TEdit(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('EditFieldPrecision')).Text := IntToStr(FieldDef.Precision);
    TComboBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbDefaultValue')).Text := FieldDef.DefaultValue;
    TCheckBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbPrimaryKey')).Checked := FieldDef.PrimaryKey;
    TCheckBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbAutoInc')).Checked := FieldDef.AutoInc;
    TCheckBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbNotNull')).Checked := FieldDef.NotNull;
    TCheckBox(SqlitePassCreateTableDlg.CtrlGrid.ControlByName('CbUnique')).Checked := FieldDef.Unique;
    SqlitePassCreateTableDlg.CtrlGrid.Append;
    end;
    
SqlitePassCreateTableDlg.CtrlGrid.Delete;
SqlitePassCreateTableDlg.CtrlGrid.First;
SqlitePassCreateTableDlg.MemoSQL.Text := TableDef.Sql;
//SqlitePassCreateTableDlg.LabelManualSQL.Visible := True;

{ Applies the changes }
if SqlitePassCreateTableDlg.ShowModal = mrOk then
   begin
   BackupTableName := 'Backup-' + OriginalTableName;

   { Gets the Fields Names }
   FieldNames := '';
   For i := 0 to Pred(TableDef.FieldDefs.Count)
       do FieldNames := FieldNames + ' "' + TableDef.FieldDefs[i].FieldName + '",';
   System.Delete(FieldNames, Length(FieldNames), 1);

   Db.Engine.Transaction.Start;

   With Db.Engine do
     begin
       try
       ExecSQL('CREATE TEMPORARY TABLE "' + BackupTableName + '" (' + FieldNames + ');');
       ExecSQL('INSERT INTO "' + BackupTableName + '" SELECT ' + FieldNames +' FROM "'+ OriginalTableName + '";');
       ExecSQL('DROP TABLE "' + OriginalTableName + '";');
       ExecSQL(SqlitePassCreateTableDlg.SQL);
       ExecSQL('INSERT INTO "' + OriginalTableName + '" (' + FieldNames + ') SELECT ' + FieldNames + ' FROM "' + BackupTableName + '";');
       ExecSQL('DROP TABLE "' + BackupTableName + '";');
       Transaction.Commit;
       ShowMessage('Table ' + SqlitePassCreateTableDlg.EditTableName.Text + ' was modified.');
       { Refresh Database Info }
       ActionDatabaseRefreshExecute(Self);
       except
       ShowMessage('Modification aborted. Error while modifying table ' + SqlitePassCreateTableDlg.EditTableName.Text);
       Transaction.RollBack;
       end;
     end;
   end;
finally
SqlitePassCreateTableDlg.Free;
end;
end;

procedure TMainForm.ActionTableRenameExecute(Sender: TObject);
begin
if FormRenameItem.Execute('Rename table %s as :', DBTreeView.SelectedItem.Caption) = mrOk then
   begin
   Db.TableDefs.TableByName(DBTreeView.SelectedItem.Caption).RenameAs(FormRenameItem.EditNewName.Text);
   DBTreeView.RefreshItems;
   DBTreeView.SelectByName(FormRenameItem.EditNewName.Text, [itTable]);
   end;
end;


procedure TMainForm.ActionTableReindexExecute(Sender: TObject);
begin
   Db.TableDefs.TableByName(DBTreeView.SelectedItem.Caption).Reindex;
   ShowMessage('Table ' + DBTreeView.SelectedItem.Caption + ' is reindexed.');
end;

procedure TMainForm.ActionTableDeleteExecute(Sender: TObject);
var
CurrentItemIndex: Integer;
begin
if MessageDlg('Do you really want to delete the table : ' + DBTreeView.SelectedItem.Caption + ' ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
   begin
   CurrentItemIndex := DBTreeView.SelectedIndex;
   Db.TableDefs.DeleteTable(DBTreeView.SelectedItem.Caption);
   ActionDatabaseRefreshExecute(Sender);
   DBTreeView.SelectedIndex := CurrentItemIndex;
   end;
end;

procedure TMainForm.TsDatabaseShow(Sender: TObject);
begin
 SbDbApplyChanges.Enabled := False;
 SbDbCancelChanges.Enabled := False;
end;

procedure TMainForm.CbDbShowSystemObjectsClick(Sender: TObject);
begin
 SbDbApplyChanges.Enabled := True;
 SbDbCancelChanges.Enabled := True;
end;

procedure TMainForm.SbDbApplyChangesClick(Sender: TObject);
begin
Db.QueryTimeout := StrToInt(EditDbQueryTimeout.Text);
Db.UserTag := StrToInt(EditDbUserTag.Text);

Db.ShowSystemObjects := CbDbShowSystemObjects.Checked;
CbDbReadOnly.Checked := Db.ReadOnly;
CbDbSmartOpen.Checked := Db.SmartOpen;

{ Options }
Db.Options.CacheSize := StrToInt(EditDbCacheSize.Text);
Db.Options.CountChanges := CbDbCountChanges.Checked;
Db.Options.CaseSensitiveLike := CbDbCaseSensitiveLike.Checked;
Db.Options.EmptyResultCallback := CbDbEmptyResultCallback.Checked;
Db.Options.FullColumnNames := CbDbFullColumnName.Checked;
Db.Options.AutoVacuum := CbDbVacuumType.ItemIndex;

EditDbTemporaryStorage.Text := '';
{ Synchronous }

end;

procedure TMainForm.EditDbQueryTimeoutKeyPress(Sender: TObject;
  var Key: Char);
begin
 if Not (Key in [#8, '0'..'9']) then Key := #0;
end;

procedure TMainForm.ActionTableEmptyExecute(Sender: TObject);
begin
if MessageDlg('Do you really want to remove all the data from the table : ' + DBTreeView.SelectedItem.Caption + ' ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
   begin
   Dataset.EmptyTable;
   SbDatasetRefresh.Click;
   end;
end;

procedure TMainForm.ActionSQLStmtCreateNewExecute(Sender: TObject);
begin
With PageControl do
     begin
     Pages[0].Tabvisible := False;
     Pages[1].Tabvisible := False;
     Pages[2].Tabvisible := True;
     Visible := True;
     MemoSQLStmt.SetFocus;
     if MemoSQLStmt.Lines.Count > 0 then
        begin
        MemoSQLStmt.SelectAll;
         if MessageDlg('Do you really want to clear the current SQL statement ? ', mtWarning, [mbYes, mbNo], 0) = mrYes then
           begin
           LabelSQLStmtName.Caption := '';
           MemoSQLStmt.Clear;
           end;
        end;
     end;
end;

procedure TMainForm.ActionSQLStmtDeleteExecute(Sender: TObject);
var
CurrentItemIndex: Integer;
begin
if MessageDlg('Do you really want to delete the ' + DBTreeView.SelectedItem.Caption + ' SQL statement ? ', mtWarning, [mbYes, mbNo], 0) = mrYes then
           begin
           CurrentItemIndex := DBTreeView.SelectedIndex;
           MemoSQLStmt.Clear;
           Db.SQLStmtDefs.DeleteSQLStmt(DBTreeView.SelectedItem.Caption);
           LabelSQLStmtName.Caption := '';
           DBTreeView.RefreshItems;
           DBTreeView.SelectedIndex := CurrentItemIndex;
           end;
end;

procedure TMainForm.ActionSQLStmtRenameExecute(Sender: TObject);
begin
if FormRenameItem.Execute('Rename SQL statement %s as :', DBTreeView.SelectedItem.Caption) = mrOk then
   begin
   Db.SQLStmtDefs.RenameSQLStmt(DBTreeView.SelectedItem.Caption, FormRenameItem.EditNewName.Text);
   DBTreeView.RefreshItems;
   end;
end;

procedure TMainForm.ActionTableSaveAsViewExecute(Sender: TObject);
begin
if FormRenameItem.Execute('Enter the view name : ', '') = mrOk then
   begin
   Db.Views.CreateView(FormRenameItem.EditNewName.Text, MemoSqlSelectStmt.Text);
   DBTreeView.RefreshItems;
   end;
end;

procedure TMainForm.ActionViewCreateNewExecute(Sender: TObject);
begin
 ActionSQLStmtCreateNewExecute(Sender);
end;

procedure TMainForm.ActionViewDeleteExecute(Sender: TObject);
begin
 Db.Views.DeleteView(DBTreeView.SelectedItem.Caption);
 DBTreeView.RefreshItems;
end;

procedure TMainForm.ActionSQLExecuteExecute(Sender: TObject);
begin
SQLDirectDataset.Close;
SQLDirectDataset.ReadOnly := CbSQLQueryIsReadOnly.Checked;
SQLDirectDataset.SQL.Clear;
SQLDirectDataset.SQL := TStringList(MemoSqlStmt.Lines);
PanelSQLResult.Visible := (SQLDirectDataset.SQLSelectStmt.SQLType = stSelect);

if PanelSQLResult.Visible
   then begin
        SQLDirectDataset.Open;
        SQLDirectDataset.SQLSelectStmt.SQL := SQLDirectDataset.SQL.Text;
        SQLDirectDataset.SQLSelectStmt.Prepare;
        MemoSqlStmt.Lines.Text := SQLDirectDataset.SQLSelectStmt.SQL;
        end
   else begin
        Db.Engine.ExecQuery(MemoSQLStmt.Lines.Text);
        ActionDatabaseRefreshExecute(Sender);
        end;
end;

procedure TMainForm.SbClosePanelSQLResultClick(Sender: TObject);
begin
 PanelSQLResult.Visible := False;
end;


{ ImageList / Menu / Button Utilities }

procedure TMainForm.ApplicationIdleHandler(Sender: TObject; var Done: Boolean);
begin
 {$IFNDEF FPC}
 RefreshMenuImages;
 {$ENDIF}
 RefreshStatusBar;
 RefreshActions;
 Done := True;
end;

{ The Following procedures are used to ensure correct image display with Delphi 4
  using classic TImageList component }
{$IFNDEF FPC}
procedure TMainForm.InitMenuImages;
var
i: Integer;
Image: TImage;
begin
ImageList.Width := 32;
ImageList.Clear;
Image := TImage.Create(Self);

Image.Picture.Bitmap.Assign(ImageDataset.Picture.Bitmap); { TODO // should be removed, but seems necessary to init picture }
Image.Picture.Bitmap.Height := 16;
Image.Picture.Bitmap.Width := 32;

for i := 0 to Pred(ImageListEnabled.Count) do
    begin
    Image.Picture.Bitmap.Canvas.FillRect(Rect(0,0,32,15));
    ImageListEnabled.Draw(Image.Picture.Bitmap.Canvas,0,0,i);
    if i < ImageListDisabled.Count
       then ImageListDisabled.Draw(Image.Picture.Bitmap.Canvas,16,0,i)
       else ImageListEnabled.Draw(Image.Picture.Bitmap.Canvas,16,0,i);
    ImageList.Add(Image.picture.Bitmap, Image.picture.Bitmap);
    end;
Image.Picture := nil;
Image.Free;
MainActionList.Images := ImageList;
ActionListDatabase.Images := ImageList;
ActionListDataset.Images := ImageList;
DBActionListDataset.Images := ImageList;
DBActionListSQLDataset.Images := ImageList;
ActionListIndexes.Images := ImageList;
ActionListTables.Images := ImageList;
ActionListQueries.Images := ImageList;
ActionListViews.Images := ImageList;
ActionListTriggers.Images := ImageList;
ActionListSQLStmts.Images := ImageList;
end;


function TMainForm.GetMenuItemImage(MenuItem: TMenuItem): Boolean;
var
SpeedButtonBmp, MenuBmp: TBitmap;
DestRect, SourceRect: TRect;
ImageIdx: Integer;
begin

SpeedButtonBmp := TBitmap.Create;
MenuBmp := TBitmap.Create;

try
Result := False;
if MenuItem = nil then Exit;
if (MenuItem.Enabled and (MenuItem.Tag = 1)) or ((MenuItem.Tag = 2) and not MenuItem.Enabled) then Exit;
SpeedButtonBmp.Width := 32;
SpeedButtonBmp.Height := 16;
MenuBmp.Width := 16;
MenuBmp.Height := 16;
DestRect := Rect(0,0,MenuBmp.Width,MenuBmp.Height);

If Assigned(MenuItem.Action) then
   begin
   ImageIdx := TAction(MenuItem.Action).ImageIndex;
   if ImageIdx <> -1 then
      begin
      SpeedButtonBmp.Canvas.Brush.Color := clWhite;
      SpeedButtonBmp.Canvas.Brush.Style := bsSolid;
      SpeedButtonBmp.Canvas.FillRect(DestRect);
      ImageList.GetBitmap(ImageIdx, SpeedButtonBmp);
      if MenuItem.Enabled
         then begin
              SourceRect := Rect(0,0,16,16);
              MenuItem.Tag := 1;
              end
         else begin
              SourceRect := Rect(16,0,32,16);
              MenuItem.Tag := 2;
              end;
      MenuBmp.Canvas.CopyRect(DestRect, SpeedButtonBmp.Canvas, SourceRect);
      MenuItem.Bitmap.Assign(MenuBmp);
      Result := True;
      end;
   end;
finally
MenuBmp.Free;
SpeedButtonBmp.Free;
end;
end;

procedure TMainForm.RefreshMenuImages;
var
i, j: Integer;
SubMenu: TMenuItem;
NeedUpdate: Boolean;
begin
NeedUpdate := False;
MainMenu.Images := nil;
For i := 0 to Pred(MainMenu.Items.Count) do
    begin
    SubMenu := MainMenu.Items[i];
    for j := 0 to Pred(SubMenu.Count)
        do if GetMenuItemImage(SubMenu[j])
              then NeedUpdate := True;
    end;
If NeedUpdate then
   begin
  { Sends a fake Menu change to force Menu
    to display images - One call per menu }
   ActionDatabaseOpen.Visible := False;
   ActionDatabaseOpen.Visible := True;
   ActionTableCreateNew.Visible := False;
   ActionTableCreateNew.Visible := True;
   ActionQueryCreateNew.Visible := False;
   ActionQueryCreateNew.Visible := True;
   ActionViewCreateNew.Visible := False;
   ActionViewCreateNew.Visible := True;
   ActionTriggerCreateNew.Visible := False;
   ActionTriggerCreateNew.Visible := True;
   ActionSQLStmtCreateNew.Visible := False;
   ActionSQLStmtCreateNew.Visible := True;
   end;
end;
{$ENDIF}

{ This procedure is used to avoid manual editing of the Speedbuttons.Glyph property
  every time the MainForm.'dfm' file is converted to MainForm.'lfm' }
procedure TMainForm.InitToolbarImages;

 procedure InitButtonImage(Btn: TSpeedButton; BtnAction: TAction);
   begin
    {$IFNDEF FPC}
    Btn.NumGlyphs := 2;
    {$ELSE}
    Btn.NumGlyphs := 1;
    {$ENDIF}
    Btn.Glyph := nil;
    Btn.Action := nil;
    Btn.Action := BtnAction;
   end;

begin
 { Database }
 InitButtonImage(SbDatabaseOpen, ActionDatabaseOpen);
 InitButtonImage(SbDatabaseTransactionStart, ActionDatabaseTransactionStart);
 InitButtonImage(SbDatabaseTransactionCommit, ActionDatabaseTransactionCommit);
 InitButtonImage(SbDatabaseTransactionRollback, ActionDatabaseTransactionRollback);
 InitButtonImage(SbDatabaseClose, ActionDatabaseClose);
 InitButtonImage(SbDatabaseAttach, ActionDatabaseAttach);
 InitButtonImage(SbDatabaseDetach, ActionDatabaseDetach);
 InitButtonImage(SbDatabaseCompactSize, ActionDatabaseCompactSize);
 InitButtonImage(SbDatabaseCheckIntegrity, ActionDatabaseCheckIntegrity);
 InitButtonImage(SbDatabaseRefresh, ActionDatabaseRefresh);
 InitButtonImage(SbDatabaseShowErrorLog, ActionDatabaseShowErrorLog);

 { SQL }
 InitButtonImage(SbDatabaseShowSQLPage, ActionShowSQLPage);

 { Dataset }
 InitButtonImage(SbDatasetRefresh, ActionDatasetRefresh);
 InitButtonImage(SbDatasetShowSortDialog, ActionDatasetShowSortDialog);
 InitButtonImage(SbDatasetFilterOnSelection, ActionDatasetFilterOnSelection);
 InitButtonImage(SbDatasetShowFilterDialog, ActionDatasetShowFilterDialog);
 InitButtonImage(SbDatasetFilterOnOff, ActionDatasetFilterOnOff);
 InitButtonImage(SbDatasetShowLocateDialog, ActionDatasetShowLocateDialog);
 InitButtonImage(SbDatasetLocateFirst, ActionDatasetLocateFirst);
 InitButtonImage(SbDatasetLocatePrior, ActionDatasetLocatePrior);
 InitButtonImage(SbDatasetLocateNext, ActionDatasetLocateNext);
 InitButtonImage(SbDatasetLocateLast, ActionDatasetLocateLast);
 InitButtonImage(SbDatasetShowParserInfos, ActionDatasetShowParserInfos);

 { Tables }
(* InitButtonImage(SbTableCreateNew, ActionTableCreateNew);
 InitButtonImage(SbTableModify, ActionTableModify);
 InitButtonImage(SbTableDelete, ActionTableDelete);
 InitButtonImage(SbTableRename, ActionTableRename);
 InitButtonImage(SbTableEmpty, ActionTableEmpty);
 InitButtonImage(SbTableReindex, ActionTableReindex);
 InitButtonImage(SbTableSaveAsView, ActionTableSaveAsView);*)

end;


procedure TMainForm.ActionDatabaseCheckIntegrityExecute(Sender: TObject);
begin
// TODO
ShowMessage('Not implemented !');
end;

procedure TMainForm.PopupMenusPopup(Sender: TObject);
begin
RefreshActions(True);
end;

procedure TMainForm.DataSourcePlugDataChange(Sender: TObject; Field: TField);
begin
RefreshActions(True);
end;

procedure TMainForm.ActionDatabaseShowDatatypeOptionsExecute(Sender: TObject);
begin
SqlitePassDatatypeOptionsDlg := TSqlitePassDatatypeOptionsDlg.Create(Db);
SqlitePassDatatypeOptionsDlg.ShowModal;
SqlitePassDatatypeOptionsDlg.Free;
if DbGridDatasetData.Visible
   then TSqlitePassDataset(DbGridDatasetData.DataSource.DataSet).Refresh;
end;



{ ----- Refresh Actions -----
  This procedure is call every time application is 'idle' }
procedure TMainForm.RefreshActions(NeedUpdate: Boolean = False);
var
i: integer;
Enabled, IsTableSelected, IsQuerySelected,
IsViewSelected, IsSQLStmtSelected: Boolean;

begin

If Not (ActionsNeedUpdate or NeedUpdate) then Exit;

{ Database }
Enabled := Db.Connected and Assigned(DbTreeView.SelectedItem);

for i := 0 to Pred(ActionListDatabase.ActionCount) do
    TAction(ActionListDatabase.Actions[i]).Enabled := Enabled;

ActionDatabaseOpen.Enabled := Not Enabled;

{ Transactions }
ActionDatabaseTransactionStart.Enabled := Enabled and (Db.Engine.Transaction.Level = 0);
ActionDatabaseTransactionCommit.Enabled := Enabled and (Db.Engine.Transaction.Level > 0);
ActionDatabaseTransactionRollback.Enabled := Enabled and (Db.Engine.Transaction.Level > 0);

{ Attached Db }
ActionDatabaseAttach.Enabled := Enabled;
ActionDatabaseDetach.Enabled := Enabled and (Db.Databases.Count > 0);

{ Create New Db - Always TRUE }
ActionDatabaseCreateNew.Enabled := True;

{ Dataset }
Enabled := Dataset.Active and ((Not Dataset.IsEmpty) or Dataset.Filtered);
ActionDatasetRefresh.Enabled := Enabled;
ActionDatasetShowParserInfos.Enabled := Enabled;

{ SpeedButtons.Down property cannot be set directly by Actions... }
SbDatasetFilterOnSelection.Down := TAction(SbDatasetFilterOnSelection.Action).checked;
SbDatasetFilterOnOff.Down := TAction(SbDatasetFilterOnOff.Action).checked;
SbSQLDatasetFilterOnSelection.Down := TAction(SbDatasetFilterOnSelection.Action).checked;
SbSQLDatasetFilterOnOff.Down := TAction(SbDatasetFilterOnOff.Action).checked;

{ Tables }
ActionTableCreateNew.Enabled := Db.Connected;;
IsTableSelected := Assigned(DbTreeView.SelectedItem)
                  and (DbTreeView.SelectedItem.ItemType = itTable)
                  and not DbTreeView.SelectedItem.HasChildren;
ActionTableModify.Enabled  := IsTableSelected;
ActionTableRename.Enabled  := IsTableSelected;
ActionTableReindex.Enabled := IsTableSelected;
ActionTableSaveAsView.Enabled := IsTableSelected;
ActionTableEmpty.Enabled   := IsTableSelected;
ActionTableDelete.Enabled  := IsTableSelected;
ActionTableCopy.Enabled    := IsTableSelected;
ActionTableCopytoDatabase.Enabled  := IsTableSelected;
ActionTableSendToDatabase.Enabled  := IsTableSelected;

{ Queries }
ActionQueryCreateNew.Enabled := Db.Connected;
IsQuerySelected := Assigned(DbTreeView.SelectedItem)
                   and (DbTreeView.SelectedItem.ItemType = itQuery)
                   and not DbTreeView.SelectedItem.HasChildren;
ActionQueryModify.Enabled  := IsQuerySelected;
ActionQueryRename.Enabled  := IsQuerySelected;
//ActionQuerySaveAsView.Enabled := IsQuerySelected;
ActionQueryDelete.Enabled  := IsQuerySelected;

{ Views }
ActionViewCreateNew.Enabled := Db.Connected;
IsViewSelected := Assigned(DbTreeView.SelectedItem)
                  and (DbTreeView.SelectedItem.ItemType = itView)
                  and not DbTreeView.SelectedItem.HasChildren;
ActionViewModify.Enabled  := IsViewSelected;
ActionViewRename.Enabled  := IsViewSelected;
//ActionViewSaveAsView.Enabled := IsViewSelected;
ActionViewDelete.Enabled  := IsViewSelected;


{ SQL Statement }
ActionSQLStmtCreateNew.Enabled := Db.Connected;

IsSQLStmtSelected := Assigned(DbTreeView.SelectedItem)
                     and (DbTreeView.SelectedItem.ItemType in [itSQL..itSQLOthers])
                     and not DbTreeView.SelectedItem.HasChildren;
ActionSQLStmtDelete.Enabled  := IsSQLStmtSelected;
ActionSQLStmtRename.Enabled  := IsSQLStmtSelected;

{ Dataset }
if Dataset.Active
   then LabelRecordCount.Caption := 'Records count : ' + IntToStr(Dataset.RecordCount)
   else LabelRecordCount.Caption := 'No record found';

{ Errors }
if Db.DatabaseError.ErrorCount > 0
   then begin
        SbDatabaseShowErrorLog.Font.Color := clRed;
        SbDatabaseShowErrorLog.Caption := IntToStr(Db.DatabaseError.ErrorCount) + ' Logged Error(s)'
        end
   else begin
        SbDatabaseShowErrorLog.Font.Color := clGrayText;
        SbDatabaseShowErrorLog.Caption := 'No error logged';
        end;

ActionsNeedUpdate := False;
end;

{ Displays infos on Status Bar
  This procedure is call every time application is 'idle' }
procedure TMainForm.RefreshStatusBar;
begin
if Db.Connected
  then begin
       PanelLibraryVersion.Caption := ' Sqlite Engine : ' + Db.VersionInfo.SqliteLibrary;
       PanelDatabasePath.Caption := ' Database : ' + Db.Database;
       end
  else begin // Db is not Connected
       PanelLibraryVersion.Caption := ' Sqlite Engine : ...';
       PanelDatabasePath.Caption := ' Database : ...' + Db.Database;
       end;
PanelDatabaseType.Caption := ' Database type : ' + DatabaseTypeAsString;
PanelChrono.Caption := ' Elapsed Time : ' + FloatToStrF(Dataset.Database.Engine.ElapsedTime, ffNumber, 4 ,3);
PanelStatus.Hint := PanelLibraryVersion.Caption + ' ' +
             PanelDatabaseType.Caption   + ' ' +
             PanelDatabasePath.Caption   + ' ' +
             PanelChrono.Caption;
end;

procedure TMainForm.ActionTableCopyExecute(Sender: TObject);
begin
if FormRenameItem.Execute('Copy table %s as :', DBTreeView.SelectedItem.Caption) = mrOk then
   begin
   Db.TableDefs.CopyTable(DBTreeView.SelectedItem.Caption, FormRenameItem.EditNewName.Text);
   DBTreeView.RefreshItems;
   DBTreeView.SelectByName(FormRenameItem.EditNewName.Text, [itTable]);
   end;
end;

procedure TMainForm.ActionTableCopyToDatabaseExecute(Sender: TObject);
begin
// TODO
end;

procedure TMainForm.GridFieldDefsDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
const
PropertyNames: Array [0..19] of string =
 ('FieldName', 'FieldFullName', 'DisplayName', 'AutoInc', 'DataType', 'DefaultValue',
  'ForeignKey', 'Hint', 'Indexed', 'NativeDataType', 'NativeDataTypeCode',
  'NotEmpty', 'NoConstraints', 'NotNull', 'Precision', 'PrimaryKey',
  'RecordFieldIndex', 'Size', 'TableFieldNo', 'Unique');
ImageFalse = 0;
ImageCheck = 1;
ImagePrimaryKey = 2;
ImageIndex = 3;
ImageAutoInc = 4;
ImageReadOnly = 5;

   procedure DisplayText(HAlignment: TAlignment; Style: TFontStyles; Text: String);
   var
   Font: TFont;
   begin
   Font := TFont.Create;
   Font.Assign(GridFieldDefs.Font);
   Font.Style := Style;
   SqlitePassVisualTools.DisplayText(GridFieldDefs, ACol, Arow, Rect,
                                     Text, Font, HAlignment, vaCenter, Classes.Rect(4,0,0,0));
   Font.Free;
   end;


   procedure DisplayImage(HAlignment: TAlignment; IsTrue: Boolean; ImageTrueIndex, ImageFalseIndex: Integer);
   begin
   if IsTrue
      then SqlitePassVisualTools.DisplayImage(GridFieldDefs, ACol, Arow, Rect,
                                      ImageListFieldDefs, ImageTrueIndex,
                                      HAlignment, vaCenter, Classes.Rect(0,0,0,0))
      else SqlitePassVisualTools.DisplayImage(GridFieldDefs, ACol, Arow, Rect,
                                      ImageListFieldDefs, ImageFalseIndex,
                                      HAlignment, vaCenter, Classes.Rect(0,0,0,0));
   end;

var
i: Integer;

begin
if (ACol = 0)
   then DisplayText(taLeftJustify, [fsBold], PropertyNames[aRow])
   else begin
        if (ACol <= Dataset.SQLSelectStmt.FieldDefs.Count) then
           begin
             i := Pred(ACol);
             Case ARow of
               0 : DisplayText(taCenter, [fsBold], Dataset.SQLSelectStmt.FieldDefs[i].FieldName);
               1 : DisplayText(taCenter, [], Dataset.SQLSelectStmt.FieldDefs[i].FieldFullName);
               2 : DisplayText(taCenter, [],Dataset.SQLSelectStmt.FieldDefs[i].DisplayName);
               3 : DisplayImage(taCenter, Dataset.SQLSelectStmt.FieldDefs[i].AutoInc, ImageAutoInc, ImageFalse);
               4 : DisplayText(taCenter, [], FieldTypeToString(Dataset.SQLSelectStmt.FieldDefs[i].DataType));
               5 : DisplayText(taCenter, [], Dataset.SQLSelectStmt.FieldDefs[i].DefaultValue);
               6 : DisplayImage(taCenter, Dataset.SQLSelectStmt.FieldDefs[i].ForeignKey, ImageCheck, ImageFalse);
               7 : DisplayText(taCenter, [], Dataset.SQLSelectStmt.FieldDefs[i].Hint);
               8 : DisplayImage(taCenter, Dataset.SQLSelectStmt.FieldDefs[i].Indexed, ImageIndex, ImageFalse);
               9 : DisplayText(taCenter, [], Dataset.SQLSelectStmt.FieldDefs[i].NativeDataType);
               10: DisplayText(taCenter, [], IntToStr(Dataset.SQLSelectStmt.FieldDefs[i].NativeDataTypeCode));
               11: DisplayImage(taCenter, Dataset.SQLSelectStmt.FieldDefs[i].NotEmpty, ImageCheck, ImageFalse);
               12: DisplayImage(taCenter, Dataset.SQLSelectStmt.FieldDefs[i].NoConstraints, ImageCheck, ImageFalse);
               13: DisplayImage(taCenter, Dataset.SQLSelectStmt.FieldDefs[i].NotNull, ImageCheck, ImageFalse);
               14: DisplayText(taCenter, [], IntToStr(Dataset.SQLSelectStmt.FieldDefs[i].Precision));
               15: DisplayImage(taCenter, Dataset.SQLSelectStmt.FieldDefs[i].PrimaryKey, ImagePrimaryKey, ImageFalse);
               16: DisplayText(taCenter, [], IntToStr(Dataset.SQLSelectStmt.FieldDefs[i].RecordFieldIndex));
               17: DisplayText(taCenter, [], IntToStr(Dataset.SQLSelectStmt.FieldDefs[i].Size));
               18: DisplayText(taCenter, [], IntToStr(Dataset.SQLSelectStmt.FieldDefs[i].TableFieldNo));
               19: DisplayImage(taCenter, Dataset.SQLSelectStmt.FieldDefs[i].Unique, ImageCheck, ImageFalse);
               end; {Case}
           end;
       end;
end;

procedure TMainForm.ActionSQLStmtSaveToFileExecute(Sender: TObject);
begin
If SaveFileDialog.Execute
   then MemoSQLStmt.Lines.SaveToFile(SaveFileDialog.Filename);
end;

procedure TMainForm.ActionSQLStmtSaveToDatabaseExecute(Sender: TObject);
begin
if LabelSQLStmtName.Caption = '' then
   begin
   if FormRenameItem.Execute('Enter the SQL Statement Name : ', '') = mrOk
      then Db.SQLStmtDefs.CreateSQLStmt(FormRenameItem.EditNewName.Text, TStringList(MemoSQLStmt.Lines))
   end
   else Db.SQLStmtDefs.CreateSQLStmt(LabelSQLStmtName.Caption, TStringList(MemoSQLStmt.Lines));
DBTreeView.RefreshItems;
end;

procedure TMainForm.ActionSQLStmtSaveAsToDatabaseExecute(Sender: TObject);
begin
if FormRenameItem.Execute('Enter the SQL Statement Name : ', '') = mrOk then
   begin
   Db.SQLStmtDefs.CreateSQLStmt(FormRenameItem.EditNewName.Text, TStringList(MemoSQLStmt.Lines));
   DBTreeView.RefreshItems;
   end;
end;

procedure TMainForm.ActionSQLStmtSaveAsViewExecute(Sender: TObject);
begin
if FormRenameItem.Execute('Enter the view name : ', '') = mrOk then
   begin
   Db.Views.CreateView(FormRenameItem.EditNewName.Text, MemoSqlStmt.Text);
   DBTreeView.RefreshItems;
   end;
end;

procedure TMainForm.ActionSQLStmtLoadFromFileExecute(Sender: TObject);
begin
if OpenFileDialog.Execute
   then MemoSQLStmt.Lines.LoadFromFile(OpenFileDialog.FileName);
end;

procedure TMainForm.GridFieldDefsMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
Cell: TGridCoord;
begin
Cell := GridFieldDefs.MouseCoord(X, Y);
If Cell.X < 1 then Exit;
Dec(Cell.x);
Case Cell.Y of
  0 : GridFieldDefs.Hint := Dataset.SQLSelectStmt.FieldDefs[Cell.x].FieldName;
  1 : GridFieldDefs.Hint := Dataset.SQLSelectStmt.FieldDefs[Cell.x].FieldFullName;
  2 : GridFieldDefs.Hint := Dataset.SQLSelectStmt.FieldDefs[Cell.x].DisplayName;
  4 : GridFieldDefs.Hint := FieldTypeToString(Dataset.SQLSelectStmt.FieldDefs[Cell.x].DataType);
  5 : GridFieldDefs.Hint := Dataset.SQLSelectStmt.FieldDefs[Cell.x].DefaultValue;
  7 : GridFieldDefs.Hint := Dataset.SQLSelectStmt.FieldDefs[Cell.x].Hint;
  9 : GridFieldDefs.Hint := Dataset.SQLSelectStmt.FieldDefs[Cell.x].NativeDataType;
  10: GridFieldDefs.Hint := IntToStr(Dataset.SQLSelectStmt.FieldDefs[Cell.x].NativeDataTypeCode);
  11: GridFieldDefs.Hint := IntToStr(Dataset.SQLSelectStmt.FieldDefs[Cell.x].Precision);
  16: GridFieldDefs.Hint := IntToStr(Dataset.SQLSelectStmt.FieldDefs[Cell.x].RecordFieldIndex);
  17: GridFieldDefs.Hint := IntToStr(Dataset.SQLSelectStmt.FieldDefs[Cell.x].Size);
  18: GridFieldDefs.Hint := IntToStr(Dataset.SQLSelectStmt.FieldDefs[Cell.x].TableFieldNo);
  end;
end;

procedure TMainForm.ActionDatasetShowParserInfosExecute(Sender: TObject);
begin
SqlitePassParserDlg := TSqlitePassParserDlg.Create(Self, Dataset);
SqlitePassParserDlg.ShowModal;
SqlitePassParserDlg.Free;
end;

procedure TMainForm.DBGridDatasetDataTitleClick(Column: TColumn);
begin
SortDbGrid(DBGridDatasetData, Column);
end;

procedure TMainForm.DBGridSqlDirectTitleClick(Column: TColumn);
begin
SortDbGrid(DBGridSQLDirect, Column);
end;

procedure TMainForm.SbShowDebuggerClick(Sender: TObject);
begin
{ Debugger }
{$IFDEF DEBUG_SQLITEPASS}
Db.debugger.Form.Visible := True;
Db.debugger.Form.SetFocus;
{$ENDIF}
end;

procedure TMainForm.SbSaveDebuggerOutputClick(Sender: TObject);
{ Debugger }
{$IFDEF DEBUG_SQLITEPASS}
var
Path: String;
{$ENDIF}
begin
{ Debugger }
{$IFDEF DEBUG_SQLITEPASS}
Path := GetExeDir;
Db.debugger.SaveToFile(Path + '\SQLitePassDboTest_Debugger.txt');
{$ENDIF}
end;

procedure TMainForm.DBTreeViewSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
 ShowDbItem;
end;

procedure TMainForm.PanelTvResize(Sender: TObject);
begin
DBTreeView.ColWidths[1] := PanelTv.ClientWidth;
end;


initialization
 {$IFDEF FPC}
  {$I SQLitePassDboTest.lrs}
 {$ENDIF}
end.




