
{$IFDEF FPC}

 {$mode delphi}
 {$H+}
 {$T+} //Force Pointer Type conversion
 {$B-}
 {$DEFINE HasInline} // Support function compiler inlining
 {$DEFINE HasftWideMemo} // Support Unicode ftWideMemo
 {$DEFINE NeedSqlitePassWideStringUtils}
{$ELSE} // Not FPC ?

  {$IFDEF WIN32}

//# VER80 - Delphi 1
//# VER90 - Delphi 2
//# VER100 - Delphi 3
//# VER120 - Delphi 4
//# VER130 - Delphi 5
//# VER140 - Delphi 6
//# VER150 - Delphi 7
//# VER160 - Delphi 8
//# VER170 - Delphi 2005
//# VER180 - Delphi 2006
//# VER180 - Delphi 2007
//# VER185 - Delphi 2007


    {$IFDEF VER200}
      {$DEFINE Delphi2009}
      {$DEFINE HasInline}
      {$DEFINE HasftWideMemo} // Support Unicode ftWideMemo
    {$ENDIF VER200}

    {$IFDEF VER185}
      {$DEFINE Delphi2007}
      {$DEFINE HasInline}
      {$DEFINE HasftWideMemo} // Support Unicode ftWideMemo
      {.$DEFINE NeedUTF8Vcl}
    {$ENDIF VER185}

    {$IFDEF VER180}
      {$DEFINE Delphi2007}
      {$DEFINE Delphi2006}
      {$DEFINE HasInline}
      {$DEFINE HasftWideMemo} // Support Unicode ftWideMemo
      {.$DEFINE NeedUTF8Vcl}
    {$ENDIF ver180}

    {$IFDEF VER170}
      {$DEFINE Delphi8}
      {$DEFINE Delphi7}
      {$DEFINE Delphi6}
      {$DEFINE HasInline}
      {$DEFINE HasftWideMemo} // Support Unicode ftWideMemo
      {.$DEFINE NeedUTF8Vcl}
    {$ENDIF ver170}

    {$IFDEF VER160}
      {$DEFINE Delphi8}
      {$DEFINE Delphi7}
      {$DEFINE Delphi6}
      {$DEFINE HasftWideMemo} // Support Unicode ftWideMemo
      {$DEFINE NeedSqlitePassWideStringUtils}
      {.$DEFINE NeedUTF8Vcl}
    {$ENDIF}

    {$IFDEF VER150}
      {$DEFINE Delphi7}
      {$DEFINE Delphi6}
      {$DEFINE HasftWideMemo} // Support Unicode ftWideMemo
      {$DEFINE NeedSqlitePassWideStringUtils}
      {.$DEFINE NeedUTF8Vcl}
    {$ENDIF}

    {$IFDEF VER140}
      {$DEFINE Delphi6}
      {.$DEFINE NeedUTF8Vcl}
      {$DEFINE NeedSqlitePassUnicodeUtils}
      {$DEFINE NeedSqlitePassWideStringUtils}
    {$ENDIF}

    {$IFDEF VER130}
      {$DEFINE Delphi5}
      {$DEFINE Delphi4}
      {.$DEFINE NeedUTF8Vcl}
      {$DEFINE NeedSqlitePassUnicodeUtils}
      {$DEFINE NeedSqlitePassWideStringUtils}
    {$ENDIF}

    {$IFDEF VER120}
      {$DEFINE Delphi4}
      {.$DEFINE NeedUTF8Vcl}
      {$DEFINE NeedSqlitePassUnicodeUtils}
      {$DEFINE NeedSqlitePassWideStringUtils}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}


// TODO - CHECK COMPILER DIRECTIVES
 {$Q-,R-}
{$IFDEF DEBUG_SQLITEPASS}
 {$Q+}  {- Overflow-Checking }
 {$R+}  {- Range-Checking }
{$ELSE}
 {.$B-} {- Complete Boolean Evaluation }
 {$Q-}  {- Overflow-Checking }
 {$R-}  {- Range-Checking }
 {.$V-} {- Var-String Checking }
 {.$T-} {- Typed @ operator }
 {$X+} {- Extended syntax }
 {$P+} {- Open string params }
{$ENDIF}

{$IFDEF WIN32}
 {.$J+} {- Writeable structured consts }
 {$H+} {- Use long strings by default }
{$ENDIF}
